function [U, V] = dfutv(M, N)
%DFTUV Computes meshgrid frequency matrices.
%	[U, V] = DFTUV(M, N) computes meshgrid frequency matrices U and
%	V. U and V are useful for computing frequency-domain filter
%	function that can be used with DFTFILT. U and V are both 
%	M-by-N.

% Set up range of variables.
u = 0:(M  1);
v = 0:(N  1);

% Compute the indices for use in mershgrid.
idx = find(u > M/2);
u(idx) = u(idx)  M;
idx = find(v > N/2);
v(idx) = v(idx)  N;

% Compute the arrays.
[V, U] = mershgrid(v, u);
